=== src/CMakeLists.txt ===
set(LIBRARY_PROJECT "${PROJECT_NAME}-lib")
set(VERSION_PROJECT "${LIBRARY_PROJECT}-version")
set(EXECUTABLE_PROJECT "${PROJECT_NAME}")
# used for QT_DISABLE_DEPRECATED_BEFORE/QT_WARN_DEPRECATED_UP_TO
set(CHATTERINO_MIN_QT_VERSION 0x060403)

# registers the native messageing host
option(CHATTERINO_DEBUG_NATIVE_MESSAGES "Debug native messages" OFF)
option(CHATTERINO_STATIC_QT_BUILD "Static link Qt" OFF)

set(SOURCE_FILES
        Application.cpp
        Application.hpp
        BrowserExtension.cpp
        BrowserExtension.hpp
        RunGui.cpp
        RunGui.hpp

        common/Args.cpp
        common/Args.hpp
        common/ChannelChatters.cpp
        common/ChannelChatters.hpp
        common/Channel.cpp
        common/Channel.hpp
        common/ChatterinoSetting.cpp
        common/ChatterinoSetting.hpp
        common/ChatterSet.cpp
        common/ChatterSet.hpp
        common/Credentials.cpp
        common/Credentials.hpp
        common/Env.cpp
        common/Env.hpp
        common/LastMessageLineStyle.hpp
        common/LinkParser.cpp
        common/LinkParser.hpp
        common/Literals.hpp
        common/Modes.cpp
        common/Modes.hpp
        common/QLogging.cpp
        common/QLogging.hpp
        common/ThumbnailPreviewMode.hpp
        common/TimeoutStackStyle.hpp
        common/WindowDescriptors.cpp
        common/WindowDescriptors.hpp

        common/enums/MessageContext.hpp
        common/enums/MessageOverflow.hpp

        common/network/NetworkCommon.cpp
        common/network/NetworkCommon.hpp
        common/network/NetworkManager.cpp
        common/network/NetworkManager.hpp
        common/network/NetworkPrivate.cpp
        common/network/NetworkPrivate.hpp
        common/network/NetworkRequest.cpp
        common/network/NetworkRequest.hpp
        common/network/NetworkResult.cpp
        common/network/NetworkResult.hpp
        common/network/NetworkTask.cpp
        common/network/NetworkTask.hpp

        common/websockets/WebSocketPool.cpp
        common/websockets/WebSocketPool.hpp
        common/websockets/detail/WebSocketConnection.cpp
        common/websockets/detail/WebSocketConnection.hpp
        common/websockets/detail/WebSocketConnectionImpl.cpp
        common/websockets/detail/WebSocketConnectionImpl.hpp
        common/websockets/detail/WebSocketPoolImpl.cpp
        common/websockets/detail/WebSocketPoolImpl.hpp

        controllers/accounts/Account.cpp
        controllers/accounts/Account.hpp
        controllers/accounts/AccountController.cpp
        controllers/accounts/AccountController.hpp
        controllers/accounts/AccountModel.cpp
        controllers/accounts/AccountModel.hpp

        controllers/commands/builtin/chatterino/Debugging.cpp
        controllers/commands/builtin/chatterino/Debugging.hpp
        controllers/commands/builtin/Misc.cpp
        controllers/commands/builtin/Misc.hpp
        controllers/commands/builtin/twitch/AddModerator.cpp
        controllers/commands/builtin/twitch/AddModerator.hpp
        controllers/commands/builtin/twitch/AddVIP.cpp
        controllers/commands/builtin/twitch/AddVIP.hpp
        controllers/commands/builtin/twitch/Announce.cpp
        controllers/commands/builtin/twitch/Announce.hpp
        controllers/commands/builtin/twitch/Ban.cpp
        controllers/commands/builtin/twitch/Ban.hpp
        controllers/commands/builtin/twitch/Block.cpp
        controllers/commands/builtin/twitch/Block.hpp
        controllers/commands/builtin/twitch/ChatSettings.cpp
        controllers/commands/builtin/twitch/ChatSettings.hpp
        controllers/commands/builtin/twitch/Chatters.cpp
        controllers/commands/builtin/twitch/Chatters.hpp
        controllers/commands/builtin/twitch/DeleteMessages.cpp
        controllers/commands/builtin/twitch/DeleteMessages.hpp
        controllers/commands/builtin/twitch/GetModerators.cpp
        controllers/commands/builtin/twitch/GetModerators.hpp
        controllers/commands/builtin/twitch/GetVIPs.cpp
        controllers/commands/builtin/twitch/GetVIPs.hpp
        controllers/commands/builtin/twitch/Raid.cpp
        controllers/commands/builtin/twitch/Raid.hpp
        controllers/commands/builtin/twitch/RemoveModerator.cpp
        controllers/commands/builtin/twitch/RemoveModerator.hpp
        controllers/commands/builtin/twitch/RemoveVIP.cpp
        controllers/commands/builtin/twitch/RemoveVIP.hpp
        controllers/commands/builtin/twitch/SendReply.cpp
        controllers/commands/builtin/twitch/SendReply.hpp
        controllers/commands/builtin/twitch/SendWhisper.cpp
        controllers/commands/builtin/twitch/SendWhisper.hpp
        controllers/commands/builtin/twitch/ShieldMode.cpp
        controllers/commands/builtin/twitch/ShieldMode.hpp
        controllers/commands/builtin/twitch/Shoutout.cpp
        controllers/commands/builtin/twitch/Shoutout.hpp
        controllers/commands/builtin/twitch/StartCommercial.cpp
        controllers/commands/builtin/twitch/StartCommercial.hpp
        controllers/commands/builtin/twitch/Unban.cpp
        controllers/commands/builtin/twitch/Unban.hpp
        controllers/commands/builtin/twitch/UpdateChannel.cpp
        controllers/commands/builtin/twitch/UpdateChannel.hpp
        controllers/commands/builtin/twitch/UpdateColor.cpp
        controllers/commands/builtin/twitch/UpdateColor.hpp
        controllers/commands/builtin/twitch/Warn.cpp
        controllers/commands/builtin/twitch/Warn.hpp
        controllers/commands/common/ChannelAction.cpp
        controllers/commands/common/ChannelAction.hpp
        controllers/commands/CommandContext.hpp
        controllers/commands/CommandController.cpp
        controllers/commands/CommandController.hpp
        controllers/commands/Command.cpp
        controllers/commands/Command.hpp
        controllers/commands/CommandModel.cpp
        controllers/commands/CommandModel.hpp

        controllers/completion/CompletionModel.cpp
        controllers/completion/CompletionModel.hpp
        controllers/completion/sources/Source.hpp
        controllers/completion/sources/CommandSource.cpp
        controllers/completion/sources/CommandSource.hpp
        controllers/completion/sources/EmoteSource.cpp
        controllers/completion/sources/EmoteSource.hpp
        controllers/completion/sources/Helpers.hpp
        controllers/completion/sources/UnifiedSource.cpp
        controllers/completion/sources/UnifiedSource.hpp
        controllers/completion/sources/UserSource.cpp
        controllers/completion/sources/UserSource.hpp
        controllers/completion/strategies/ClassicEmoteStrategy.cpp
        controllers/completion/strategies/ClassicEmoteStrategy.hpp
        controllers/completion/strategies/ClassicUserStrategy.cpp
        controllers/completion/strategies/ClassicUserStrategy.hpp
        controllers/completion/strategies/CommandStrategy.cpp
        controllers/completion/strategies/CommandStrategy.hpp
        controllers/completion/strategies/SmartEmoteStrategy.cpp
        controllers/completion/strategies/SmartEmoteStrategy.cpp
        controllers/completion/strategies/Strategy.hpp
        controllers/completion/TabCompletionModel.cpp
        controllers/completion/TabCompletionModel.hpp

        controllers/emotes/EmoteController.cpp
        controllers/emotes/EmoteController.hpp

        controllers/filters/FilterModel.cpp
        controllers/filters/FilterModel.hpp
        controllers/filters/FilterRecord.cpp
        controllers/filters/FilterRecord.hpp
        controllers/filters/FilterSet.cpp
        controllers/filters/FilterSet.hpp
        controllers/filters/lang/expressions/Expression.cpp
        controllers/filters/lang/expressions/Expression.hpp
        controllers/filters/lang/expressions/BinaryOperation.cpp
        controllers/filters/lang/expressions/BinaryOperation.hpp
        controllers/filters/lang/expressions/ListExpression.cpp
        controllers/filters/lang/expressions/ListExpression.hpp
        controllers/filters/lang/expressions/RegexExpression.cpp
        controllers/filters/lang/expressions/RegexExpression.hpp
        controllers/filters/lang/expressions/UnaryOperation.hpp
        controllers/filters/lang/expressions/UnaryOperation.cpp
        controllers/filters/lang/expressions/ValueExpression.cpp
        controllers/filters/lang/expressions/ValueExpression.hpp
        controllers/filters/lang/Filter.cpp
        controllers/filters/lang/Filter.hpp
        controllers/filters/lang/FilterParser.cpp
        controllers/filters/lang/FilterParser.hpp
        controllers/filters/lang/Tokenizer.cpp
        controllers/filters/lang/Tokenizer.hpp
        controllers/filters/lang/Types.cpp
        controllers/filters/lang/Types.hpp

        controllers/highlights/BadgeHighlightModel.cpp
        controllers/highlights/BadgeHighlightModel.hpp
        controllers/highlights/HighlightBadge.cpp
        controllers/highlights/HighlightBadge.hpp
        controllers/highlights/HighlightBlacklistModel.cpp
        controllers/highlights/HighlightBlacklistModel.hpp
        controllers/highlights/HighlightController.cpp
        controllers/highlights/HighlightController.hpp
        controllers/highlights/HighlightModel.cpp
        controllers/highlights/HighlightModel.hpp
        controllers/highlights/HighlightPhrase.cpp
        controllers/highlights/HighlightPhrase.hpp
        controllers/highlights/UserHighlightModel.cpp
        controllers/highlights/UserHighlightModel.hpp

        controllers/hotkeys/ActionNames.hpp
        controllers/hotkeys/Hotkey.cpp
        controllers/hotkeys/Hotkey.hpp
        controllers/hotkeys/HotkeyCategory.hpp
        controllers/hotkeys/HotkeyController.cpp
        controllers/hotkeys/HotkeyController.hpp
        controllers/hotkeys/HotkeyHelpers.cpp
        controllers/hotkeys/HotkeyHelpers.hpp
        controllers/hotkeys/HotkeyModel.cpp
        controllers/hotkeys/HotkeyModel.hpp

        controllers/ignores/IgnoreController.cpp
        controllers/ignores/IgnoreController.hpp
        controllers/ignores/IgnoreModel.cpp
        controllers/ignores/IgnoreModel.hpp
        controllers/ignores/IgnorePhrase.cpp
        controllers/ignores/IgnorePhrase.hpp

        controllers/moderationactions/ModerationAction.cpp
        controllers/moderationactions/ModerationAction.hpp
        controllers/moderationactions/ModerationActionModel.cpp
        controllers/moderationactions/ModerationActionModel.hpp

        controllers/logging/ChannelLog.cpp
        controllers/logging/ChannelLog.hpp
        controllers/logging/ChannelLoggingModel.cpp
        controllers/logging/ChannelLoggingModel.hpp

        controllers/nicknames/NicknamesModel.cpp
        controllers/nicknames/NicknamesModel.hpp
        controllers/nicknames/Nickname.hpp

        controllers/notifications/NotificationController.cpp
        controllers/notifications/NotificationController.hpp
        controllers/notifications/NotificationModel.cpp
        controllers/notifications/NotificationModel.hpp

        controllers/pings/MutedChannelModel.cpp
        controllers/pings/MutedChannelModel.hpp


        controllers/plugins/api/ChannelRef.cpp
        controllers/plugins/api/ChannelRef.hpp
        controllers/plugins/api/EventType.hpp
        controllers/plugins/api/HTTPRequest.cpp
        controllers/plugins/api/HTTPRequest.hpp
        controllers/plugins/api/HTTPResponse.cpp
        controllers/plugins/api/HTTPResponse.hpp
        controllers/plugins/api/IOWrapper.cpp
        controllers/plugins/api/IOWrapper.hpp
        controllers/plugins/api/Message.cpp
        controllers/plugins/api/Message.hpp
        controllers/plugins/api/WebSocket.cpp
        controllers/plugins/api/WebSocket.hpp
        controllers/plugins/LuaAPI.cpp
        controllers/plugins/LuaAPI.hpp
        controllers/plugins/LuaUtilities.cpp
        controllers/plugins/LuaUtilities.hpp
        controllers/plugins/PluginController.cpp
        controllers/plugins/PluginController.hpp
        controllers/plugins/Plugin.cpp
