=== debian/changelog ===
chatterino2 (1:2.5.4-1) unstable; urgency=low

  * Initial release. (Closes: #1061336)
  
 -- Chow Yoong Jin <solomoncyj@gmail.com>  Mon, 17 Nov 2025 12:37:31 +0800
