=== debian/control ===
Source: chatterino2
Maintainer: Chow Yoong Jin <solomoncyj@gmail.com>
Section: misc
Priority: optional
Homepage: https://chatterino.com/
Standards-Version: 4.7.0
Build-Depends: debhelper-compat (= 13), qt6-base-dev, qt6-svg-dev, qt6-image-formats-plugins, libboost-dev, libboost-json-dev, libnotify-dev, qt6-5compat-dev, libssl-dev, libsecret-1-dev, pkgconf, cmake, git, googletest, libminiaudio-dev, qtkeychain-qt6-dev, rapidjson-dev, ninja-build, python3-venv
Vcs-Browser: https://github.com/Chatterino/chatterino2
Vcs-Git: https://github.com/Chatterino/chatterino2
Rules-Requires-Root: no



Package: chatterino2
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}
Description:  Chat client for Twitch.tv
 Chatterino is a chat client for Twitch chat. 
 It aims to be an improved/extended version of the Twitch web chat.
