=== debian/rules ===
#!/usr/bin/make -f
override_dh_auto_configure:
	dh_auto_configure -- -G Ninja \
		-DUSE_SYSTEM_QTKEYCHAIN=ON \
		-DUSE_SYSTEM_MINIAUDIO=ON

override_dh_installchangelogs:
	dh_installchangelogs CHANGELOG.md


override_dh_auto_test:
	#no tests


%:
	dh $@
